<?php

$plugin_path = WP_CONTENT_DIR.'/plugins/'.plugin_basename(dirname(__FILE__));
$plugin_url = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__));

$q=explode('&',$_SERVER['QUERY_STRING']);
$purl='http'.((!empty($_SERVER['HTTPS'])) ? 's' : '').'://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'].'?'.$q[0];
$action=$_POST['action']?$_POST['action']:$_GET['action'];
if(isset($action)){
	$WPhtc_data=get_option('WPhtc_data');
	switch($action){
		# if reseting everything just delete the option array
		case 'reset_rules':
			delete_option('WPhtc_data');
			$echo.="All rules (Custom Author Permalink + htaccess Custom Rewrite Pairs) reset.";
			break;
		# if updating, save new rules in database and flush rewrite rules as if regenerating permalink structure
		case 'update':	
			for($i=0;$i<$_POST['WPhtc_num'];$i++){ 
				if(!empty($_POST['WPhtc_pat'.$i]) && !empty($_POST['WPhtc_sub'.$i])){
					$WPhtc_data['pats'][$i]=$_POST['WPhtc_pat'.$i];								
					$WPhtc_data['subs'][$i]=$_POST['WPhtc_sub'.$i];
					}					
				}
			if(count($WPhtc_data['pats'])>1 && $WPhtc_data['pats'][0]==''){
				unset($WPhtc_data['pats'][0],$WPhtc_data['subs'][0]);
				}
			if(is_array($WPhtc_data['pats'])&&is_array($WPhtc_data['subs'])){
				$WPhtc_data['pats']=array_values($WPhtc_data['pats']);
				$WPhtc_data['subs']=array_values($WPhtc_data['subs']);
				}
			$WPhtc_data['cap']=$_POST['WPhtc_cap'];
			update_option('WPhtc_data',$WPhtc_data);
			global $wp_rewrite;
			$wp_rewrite->flush_rules();
			$echo.="Author permalink structure and htaccess rules updated.";
			break;
		# add_rule deprecated by jQuery use below but still present just in case
		case 'add_rule':
			$add_rule=true;
			$echo='New pair available!';
			break;
		# deleting individual rewrite pair
		case 'delete_pair':
			if(isset($_GET['pair'])){
				# if it's the last pair
				if($_GET['pair']==0 && !isset($WPhtc_data['pats'][1])){
					unset($WPhtc_data['pats'], $WPhtc_data['subs']);			
					update_option('WPhtc_data',$WPhtc_data);
					$echo.="htaccess rules reset.";
					break;
					}
				unset($WPhtc_data['pats'][$_GET['pair']],$WPhtc_data['subs'][$_GET['pair']]);
				$WPhtc_data['pats']=array_values($WPhtc_data['pats']);
				$WPhtc_data['subs']=array_values($WPhtc_data['subs']);
				update_option('WPhtc_data',$WPhtc_data);
				$echo.='Pair deleted!';
				}
			break;
		}
	}
$WPhtc_data=get_option('WPhtc_data');?>
<script>
jQuery(document).ready(function(){
	init();
	function init(){
		addButton();
		}
	function addButton(){
		jQuery('.wphtc-menu .add').attr('href','#addRule').click(function(){addRule();});
		}
	function addRule(){
		num=parseInt(jQuery("#WPhtc_num").val());
		if(!jQuery('.wphtc-menu .add').hasClass('doing')){
			jQuery('.wphtc-menu .add').addClass('doing');
			lastrule=jQuery("#htaccess-rules tr:last").attr('id').split('-');
			newrule=parseInt(lastrule[1])+1;
			jQuery("#htaccess-rules tr:last").clone().attr('id','rule-'+newrule).hide().insertAfter("#htaccess-rules tr:last").fadeIn('slow',function(){jQuery('.wphtc-menu .add').removeClass('doing');}).css({display: ""});
			jQuery("#rule-"+newrule+" input:first").val('').attr('name','WPhtc_pat'+newrule);
			jQuery("#rule-"+newrule+" input:last").val('').attr('name','WPhtc_sub'+newrule);
			jQuery("#rule-"+newrule+" td:last").empty();
			jQuery("#WPhtc_num").val(num+1);	
			}
		}
	});
</script>
<style>
	h2,h3,.wphtc-menu {float:left;}
	h3{clear:left;}
	span.description{display:block}
	.wphtc-menu {margin:1em;}
	.wphtc-menu li{display:inline;margin-right:20px;}
	.wphtc-menu img{position:relative;top:2px;}
	#wphtc-menu{margin-top:2em;}
	#htaccess-rules img{position:relative;top:4px;}
	#htaccess-rules a, .wphtc-menu a{text-decoration:none;}
	p.alignright{padding-right:20px;}
	p,.updated{clear:both;}
</style>
<div class="wrap">
	<h2>Wp htaccess Control</h2>
	<ul id="wphtc-menu" class="wphtc-menu">
		<li><a href="<?php echo $purl?>&action=reset_rules"><img src="<?php echo $plugin_url?>/gfx/icon_alert.gif"> Reset all rules</a></li>
	</ul>
	<?php if($echo!=''){?>
		<div class="updated fade" id="message" style="background-color: rgb(255, 251, 204);"><p><?php echo $echo;?></p></div>
		<?php }?>
	<form method="post" action="<?php echo $purl?>">
	<h3>Custom Author Permalink</h3>
		<table class="form-table">
			<tr valign="top">
				<th scope="row"><label for="blogdescription">Author Base</label></th>
				<td>
					<input type="text" name="WPhtc_cap" value="<?php echo $WPhtc_data['cap']; ?>" /> <code><?php bloginfo('home')?>/<em>(your-base)</em>/admin</code><br/>
					<span class="description">Permalink settings must be set and not Default (/?p=123).</span>
					<span class="description">If set, the author base will be used as shown next to the form field.</span>
					<span class="description">If you do not want to use a custom Author Permalink base just leave the field empty.</span>
					<p></p>
				</td>
			</tr>
		</table>
		<h3>Rewrite Pairs</h3>
		<ul class="wphtc-menu">
			<li><a class="add" href="<?php echo $purl?>&action=add_rule" title="Add new htaccess redirection pair"><img src="<?php echo $plugin_url?>/gfx/image_new.gif"> Add rule</a></li>
		</ul>
		<table id="htaccess-rules" class="form-table">
			<?php 
			$num=count($WPhtc_data['pats'])?count($WPhtc_data['pats']):1;
			if($add_rule){$num++;};
			for($i=0;$i<$num;$i++){?>
				<tr id="rule-<?php echo $i;?>" valign="top">
					<td><input type="text" style="width:100%" name="WPhtc_pat<?php echo $i;?>" value="<?php echo $WPhtc_data['pats'][$i]; ?>" /></td>
					<td><input type="text" style="width:100%" name="WPhtc_sub<?php echo $i;?>" value="<?php echo $WPhtc_data['subs'][$i]; ?>" /></td>
					<td><a href="<?php echo $purl ?>&action=delete_pair&pair=<?php echo $i?>"><img src="<?php echo $plugin_url?>/gfx/action_stop.gif">  Delete Pair</a></td>
				</tr>
				<?php } ?>
		</table>
		<input type="hidden" name="action" value="update" />
		<input id="WPhtc_num" type="hidden" name="WPhtc_num" value="<?php echo $num;?>" />
		<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
		</p>
	</form>
	<?php if(isset($WPhtc_data['cur_hta'],$WPhtc_data['pats'][0])){echo'<h3>Current htaccess file as it is generated by Wordpress</h3><p><code>'.$WPhtc_data['cur_hta'].'</code></p>';}?>
</div>
<p class="setting-description alignright"><small><a href="http://dardna.com/wp-htaccess-control" title="Visit WP htaccess Control page at dardna.com">WP htaccess Control</a> by <a href="http://dardna.com" title="Visit dardna.com">dardna</a>, thanks to <a href="http://www.famfamfam.com/lab/icons/mini/" title="Visit 'Mini iconset' page at FamFamFam.com">FamFamFam</a> for the icons.</small></p>