<?php
/*
Plugin Name: WP htaccess Control
Plugin URI: http://dardna.com/wp-htaccess-control
Description: Provides an interface to add custom htaccess rules to the htaccess file generated by wordpress. Also includes an improved and much more stable version of Custom Author Permalink 
Version: 1.1.4
Author: dardna
Author URI: http://dardna.com
*/

/*  Copyright 2008  António Andrade  (email : dardna@dardna.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/*

= 1.1.4 =
* Confirmed compatibility with WP 2.9.1;
* Minor gui changes;

= 1.1.3 =
* Fixing error on wphtc_cap's preg_replace commited on 1.1.2 (thank you mattcav for the report!);
* Fixing php warning on update without htaccess rules;

= 1.1.2 =
* No longer creating empty option array on install or reset (globally better option array handling);
* Confirmed compatibility with WP 2.8;
* Still some work to do on the interface;

= 1.1.1 =
* Fixing screenshot mistake;

= 1.1 =
* Separated gui file;
* Improved management and gui;

= 1.0.1 = 
* Added GNU license;

= 1.0 =
* Initial release (poor interface although working).

*/
if (!class_exists("WPhtc")) {
	class WPhtc {
		function WPhtc() { 
			}
			
		# Replacing the Wordpress Author Permalink by rewriting it's rules if we have a Custom Author Permalink, everytime the rules are flush 
		function wphtc_cap($rules){
			$WPhtc_data=get_option('WPhtc_data');
			if(isset($WPhtc_data['cap']) && $WPhtc_data['cap']!=''){
				$rules=unserialize(preg_replace('!s:(\d+):"(.*?)";!se', "'s:'.strlen('$2').':\"$2\";'",str_replace('author/',$WPhtc_data['cap'].'/',serialize($rules))));
				}
			return $rules;
			}
			
		# Adding our rule pairs to the .htaccess generated by Wordpress, everytime the rules are flush
		function wphtc_rules($wp_rewrite){
			$WPhtc_data=get_option('WPhtc_data');
			for($i=0;$i<count($WPhtc_data['pats']);$i++){
				if($WPhtc_data['pats'][$i]!=''&&$WPhtc_data['subs'][$i]!=''){
					# adding each custom rewrite pair to $wp_rewrite->non_wp_rules['pattern']='substitution'
					$wp_rewrite->non_wp_rules[$WPhtc_data['pats'][$i]]=$WPhtc_data['subs'][$i];
					}
				}
			# keeping a copy of the generated htaccess in our option array for later reviewing
			$WPhtc_data['cur_hta']='# BEGIN Wordpress<br/>'.nl2br($wp_rewrite->mod_rewrite_rules()).'# END Wordpress';
			update_option('WPhtc_data',$WPhtc_data);
			return $wp_rewrite;
			}
			
		# WP-htaccess Control options page
		function wphtc_page(){
			include (dirname (__FILE__).'/wp-htaccess-control-gui.php');
			}
		
		# Adding our optons page to the admin menu
		function ConfigureMenu(){
			add_submenu_page("options-general.php","WP htaccess Control", "WP htaControl", 6, __FILE__, array('WPhtc','wphtc_page'));
			}
		}
	} 
if (class_exists("WPhtc")) {
	$WPhtc = new WPhtc();
	}
if (isset($WPhtc)) {
	add_filter('generate_rewrite_rules', array($WPhtc,'wphtc_rules'));
	add_filter('rewrite_rules_array',array($WPhtc,'wphtc_cap'));
	add_action('admin_menu', array($WPhtc,'ConfigureMenu'));
	}
?>